#include <windows.h>
#include "exports.h"
#include "cwstart.h" 

LIBMAIN

void DLL 
_init()
{
	LibExport( "ERRCODE CutKeepSel void");
	LibExport( "ERRCODE CopyKeepSel void");
	LibExport( "ERRCODE PasteKeepSel void");
}

ERRCODE clipOpKeepSel(ERRCODE (WINAPI *)(void));

ERRCODE DLL
CutKeepSel(void)
{
	if (SysQFlags() & SYSFLAG_CLIPBOARD)
		return(clipOpKeepSel(ClipboardCut));
	else	
		return(clipOpKeepSel(BufCutToScrap));
}

ERRCODE DLL
CopyKeepSel(void)
{
	if (SysQFlags() & SYSFLAG_CLIPBOARD)
		return(clipOpKeepSel(ClipboardCopy));
	else	
		return(clipOpKeepSel(BufCopyToScrap));
}

ERRCODE DLL
PasteKeepSel(void)
{
	MarkID start, end;
	ERRCODE retVal;

	start = MarkAllocLocal();
	if (SysQFlags() & SYSFLAG_CLIPBOARD)
		retVal = ClipboardPaste();
	else	
		retVal = BufInsertScrap();
	end = MarkAllocLocal();	
	MarkGoto(start);
	MarkBeginSel(SELECTION_INCLUSIVE);
	MarkGoto(end);
	MarkEndSel();
	MarkFree(start);
	MarkFree(end);
	return(retVal);
}

ERRCODE
clipOpKeepSel(ERRCODE (WINAPI *func)(void))
{
	LPSelection selp;
	BOOL hadSel = TRUE;
	ERRCODE retval;

	if (!(selp = MemAlloc(sizeof(*selp))))
		return(-1);
	
	MarkSavePos();	
	if (!MarkGetSelInfo(selp, TRUE))
		hadSel = FALSE;
	
	retval = func();
	
	if (hadSel)
	{
		MovAbs(selp->begin.line, selp->begin.column);
		MarkBeginSel(selp->selType);
		MovAbs(selp->end.line, selp->end.column);
	}
	
	MemFree(selp);
	MarkRestorePos();
	return(retval);
}

